from Tkinter import *
import tkSimpleDialog
import tkFont
import ScrolledText
from os import * 
from time import *
import string
import thread

from Code import *



# Software zum Planspiel zum Thema Datenschutz
#
# (C) 2005-2007 Andreas Gramm - http://andreas.grammm.de
#
# Das Planspiel basiert auf der in den "Materialien zum Unterricht des Hessischen
# Instituts fuer Bildungsplanung und Schulentwicklung" 1991 in Wiesbaden veroeffentlichten
# Vorlage "Jugend im Datennetz". Beschreibung des Planspiels und Materialien der Vorlage:
#   http://ddi.informatik.hu-berlin.de/schule/unterrichtsmaterial/JugendImDatennetz.pdf
# Download der an die Software-Variante angepasste Materialien unter:
#   http://www.bebis.de/zielgruppen/lehramtsanwaerterinnen/informatik/Gesellschaft_und_Informatik/
# Hinweise zum Einsatz der Software in der Datei
#   'Hinweise zur Benutzung von Bankserver und Kassenterminals.txt'.
#
# Bugreports und weitere Anregungen willkommen an: planspiel@grammm.de


# B A N K
# Klassen:
# class Konto:                      description of a bank account
# class KontoError(Exception):      generic Exception for problems related to handling
#                                   accounts (non-existing knr, insufficient bonus, ...)
# class Bank:                       container holding a list of accounts and a transaction methods.
# class AuszugDlg:                  GUI to view a bank statement
# class BankGUI:                    GUI to manage a Bank-object


class Konto:

    fileprefix = "Konto_"
    filepostfix = ".txt"
    
    def __init__(self, nr):
        self.Nr = int(nr)
        self.Inhaber = ""
        self.PIN = 0
        self.Stand = 0.0
        
    def __str__(self):
        return "Konto " + str(self.Nr) + " fuer " + self.Inhaber + " - Stand: EUR  %.2f" % (self.Stand)

    def Einrichten(self, inhaber, pin):
        self.Inhaber = inhaber
        self.PIN = encode(pin)
        try:
            datei = open(Konto.fileprefix + str(self.Nr) + Konto.filepostfix, O_CREAT)
            close(datei)
            datei = open(Konto.fileprefix + str(self.Nr) + Konto.filepostfix, O_RDWR)
            write(datei, "\n Konto " + str(self.Nr) + " eingerichtet fuer " + self.Inhaber + strftime(" am %d.%m.%y um %H:%M:%S", gmtime()) + ". PIN: " + self.PIN)
            write(datei, ", Stand: EUR " + string.rjust("%.2f" % (self.Stand),7) + "\n")
            close(datei)
            print str(self) + " - eingerichtet."
        except OSError, msg:
            raise  KontoError("Konnte Datei fuer Konto " + str(self.Nr) + " nicht anlegen: " + str(msg))

    def AusDateiEinlesen(self):
        try:
            datei = open(Konto.fileprefix + str(self.Nr) + Konto.filepostfix, O_RDWR)
            KontoLog = read(datei, 100000)
            Kopfzeile = KontoLog.split('\n')[1]
            nr = Kopfzeile.split('Konto ')[1].split(' eingerichtet')[0]
            if int(self.Nr) != int(nr):
                raise  KontoError("Konnte Datei fuer Konto " + str(nr) + " nicht lesen: Verschiedene Kontonummern")                
            self.Inhaber = Kopfzeile.split('fuer ')[1].split(' am')[0]
            self.PIN = (Kopfzeile.split('PIN: ')[1].split(', Stand:')[0])
            KontoLog = KontoLog.split()
            if len(KontoLog)>0:
                self.Stand = float( KontoLog[len(KontoLog)-1] )
            close(datei)
            print str(self) + " - aus bestehender Datei eingelesen."
        except OSError:
            raise  KontoError("Konnte Datei fuer Konto " + str(self.Nr) + " nicht lesen.")
        
    def Gutschreiben(self, von, betrag):
        self.Stand = self.Stand + betrag
        report = "\n " + strftime("%d.%m.%y  %H:%M:%S ", localtime()) + "  "
        if von != "Bareinzahlung":  report += "Gutschrift von "
        report += von
        report += (60-len(report))*' '
        report += "+ EUR " + string.rjust("%.2f" % (betrag),7) + "      "
        report += "Stand: EUR " + string.rjust("%.2f" % (self.Stand),7) + "\n"
        datei = open(Konto.fileprefix + str(self.Nr) + Konto.filepostfix, O_RDWR)
        S = read(datei, 10000)
        write(datei, report)
        close(datei)
        print "Konto " + str(self.Nr) + " EUR %.2f" % (betrag) + " gutgeschrieben - Stand: EUR %.2f" % (self.Stand) 

    def Abbuchen(self, ziel, betrag, pin):
        if pin != self.PIN:
            raise  KontoError("Falsche PIN-Angabe fuer Konto " + str(self.Nr) + " .")
        if self.Stand - betrag < 0:
            raise KontoError("Konto " + str(self.Nr) + " hat nicht genug Guthaben um EUR " + str(betrag) + " abzubuchen." )
        self.Stand = self.Stand - betrag
        report = "\n " + strftime("%d.%m.%y  %H:%M:%S ", localtime()) + "  Ueberweisung an " + ziel
        report += (60-len(report))*' '
        report += "- EUR " + string.rjust("%.2f" % (betrag),7) + "      "
        report += "Stand: EUR " + string.rjust("%.2f" % (self.Stand),7) + "\n"
        datei = open(Konto.fileprefix + str(self.Nr) + Konto.filepostfix, O_RDWR)
        S = read(datei, 10000)
        write(datei, report)
        close(datei)
        print "Von Konto " + str(self.Nr) + " EUR %.2f" % (betrag) + " abgebucht - Stand: EUR %.2f" % (self.Stand) 
        
    def GetStatement(self):
        datei = open(Konto.fileprefix + str(self.Nr) + Konto.filepostfix, O_RDONLY)
        S = read(datei, 100000)
        close(datei)
        return S        



class KontoError(Exception):
    
    def __init__(self, msg):
        self.value = "Kontofehler: " + msg

    def __str__(self):
        return repr(self.value)


        
class Bank:
    
    def __init__(self):
        self.Konten = []
        self.Beobachter = []
        BankDateien = listdir(".")
#        print
#        print BankDateien
        for d in BankDateien:
            l = len(Konto.fileprefix)
            if d[0:l] == Konto.fileprefix:
                try:
                    knr = int(d[l:len(d)-len(Konto.filepostfix)])
                except TypeError, msg:
                    raise KontoError("Konnte Kontonummer in Dateiname " + d + " nicht lesen.")
                K = Konto(knr)
                K.AusDateiEinlesen()
                self.Konten.append(K)
        print

    def BeobachterRegistrieren(self, beobachter):
        self.Beobachter.append(beobachter)
        
    def GetKonto(self, knr):
        for k in self.Konten:
            if k.Nr == int(knr):
                return k
        raise KontoError("Die Bank fuehrt kein Konto mit Kontonummer " + str(knr))

    def KontoAnlegen(self, knr, inhaber, pin):
        vergeben = 0
        try:
            self.GetKonto(knr)
            vergeben = 1
        except KontoError:
            pass
        if vergeben:
            raise KontoError("Kontonummer " + str(knr) + " ist bereits vergeben")
        else:
            K = Konto(int(knr))
            K.Einrichten(inhaber, pin)
            self.Konten.append(K)
        
    def Transaktion(self, knr_von, knr_nach, betrag, PIN_von):
        K_von = self.GetKonto(knr_von)
        K_nach = self.GetKonto(knr_nach)
        K_von.Abbuchen(K_nach.Inhaber, betrag, PIN_von)
        K_nach.Gutschreiben(K_von.Inhaber, betrag)
#        print "EUR %.2f" % (betrag) + " von Konto " + str(knr_von) + " (PIN: " + str(K_von.PIN) + ") auf Konto " + str(knr_nach) + " (PIN: " + str(K_nach.PIN) + ") gebucht."
        print "EUR %.2f" % (betrag) + " von Konto " + str(knr_von) + " auf Konto " + str(knr_nach) + " gebucht."
        for b in self.Beobachter:
            b.Update()



class AuszugDlg:
    
    def __init__(self, nr, auszug):
        
        self.FENSTER=Tk()
        self.FENSTER.geometry("570x620")
        self.FENSTER.resizable(width="false", height="false")
        self.FENSTER.title("Auszug fuer Konto " + str(nr))

        self.RAHMEN = Frame(self.FENSTER)
        self.RAHMEN.pack(expand=1, fill=BOTH) 

        f = tkFont.Font(family="Times", size="8")
        self.TEXT = ScrolledText.ScrolledText(self.RAHMEN,width=90,height=24,background='white') #,font=f)
        self.TEXT.insert(END,auszug)
        self.TEXT.pack(fill=BOTH,expand=YES)

        self.BUTTON_Schliessen = Button(self.RAHMEN, text=" Ansicht Schliessen ", width=15, command=self.FENSTER.destroy)
        self.BUTTON_Schliessen.pack(side=BOTTOM)



class NeuesKontoDlg(tkSimpleDialog.Dialog):

    def body(self, master):
        self.title("Neues Konto eroeffnen")

        self.LABEL_inhaber = Label(master, text="Inhaber: ")
        self.LABEL_inhaber.pack(side=TOP)
        self.ENTRY_inhaber = Entry(master,width=20)
        self.ENTRY_inhaber.pack(side=TOP)

        self.LABEL_pin = Label(master, text="PIN: ")
        self.LABEL_pin.pack(side=TOP)
        self.ENTRY_pin = Entry(master, width=5, show="*")
        self.ENTRY_pin.pack(side=TOP)

        self.LABEL_knr = Label(master, text="Knr: ")
        self.LABEL_knr.pack(side=TOP)
        self.ENTRY_knr = Entry(master,width=5)
        self.ENTRY_knr.pack(side=TOP)

        return self.ENTRY_inhaber # Fokus auf das erste Eingabefeld setzen
    
 
    def apply(self): 
        self.knr = self.ENTRY_knr.get()
        self.inhaber = self.ENTRY_inhaber.get()
        self.pin = self.ENTRY_pin.get()
        self.result = 1 ## alles ok!



class BankGUI:
    
    def __init__(self, bank):
        
        self.Bank = bank

        self.FENSTER=Tk()
        self.FENSTER.geometry("440x490")
        self.FENSTER.resizable(width="false", height="false")
        self.FENSTER.title("Bank")

        self.RAHMEN = Frame(self.FENSTER)
        self.RAHMEN.place(x=0, y=0,width=440, height=490)

        self.LABEL_Info = Label(self.RAHMEN, text="Willkommen bei der Bank!", anchor="w")
        self.LABEL_Info.place(x=50, y=20)

        # Kontodaten

        self.LABEL_Konto_Text = Label(self.RAHMEN, text="Aktuelles Konto:", anchor="w")
        self.LABEL_Konto_Text.place(x=50, y=60)

        self.LABEL_Knr = Label(self.RAHMEN, text="Kontonr. :", width=30, anchor="w")
        self.LABEL_Knr.place(x=50, y=90)
        self.knr = StringVar()
        self.knr.set("")
        self.ENTRY_knr = Entry(self.RAHMEN, textvariable=self.knr, width=5)
        self.ENTRY_knr.place(x=120, y=90)
        self.ENTRY_knr.bind("<Return>", self.AnsichtAktualisieren)
        self.ENTRY_knr.bind("<Button-1>", self.KnrLoeschen)

        self.LABEL_Inhaber_Text = Label(self.RAHMEN, text="Inhaber :", width=30, anchor="w")
        self.LABEL_Inhaber_Text.place(x=50, y=120)

        self.LABEL_Inhaber = Label(self.RAHMEN, text="", width=30, anchor="w")
        self.LABEL_Inhaber.place(x=120, y=120)

        self.LABEL_Stand_Text = Label(self.RAHMEN, text="Kontostand: ", width=30, anchor="w")
        self.LABEL_Stand_Text.place(x=50, y=150)

        self.LABEL_Stand = Label(self.RAHMEN, text="", width=30, anchor="w")
        self.LABEL_Stand.place(x=120, y=150)

        self.BUTTON_Auszug = Button(self.RAHMEN, text="Kontoauszug", width=15, command=self.Kontoauszug)
        self.BUTTON_Auszug.place(x=280, y=140)
        
        self.BUTTON_KontoEroeffnen= Button(self.RAHMEN, text="Konto eroeffnen", width=15, command=self.KontoEroeffnen)
        self.BUTTON_KontoEroeffnen.place(x=280, y=87)

        # Transaktionsdaten
        
        self.LABEL_Transaktion_Text = Label(self.RAHMEN, text="Transaktionen:", anchor="w")
        self.LABEL_Transaktion_Text.place(x=50, y=210)      

        self.LABEL_Betrag = Label(self.RAHMEN, text="Betrag :          EUR", width=30, anchor="w")
        self.LABEL_Betrag.place(x=50, y=240)
        self.betrag = StringVar()
        self.betrag.set("")
        self.ENTRY_Betrag = Entry(self.RAHMEN, textvariable=self.betrag, width=12)
        self.ENTRY_Betrag.place(x=155, y=240)

        self.BUTTON_Einzahlen = Button(self.RAHMEN, text="Bareinzahlung", width=15, command=self.Einzahlen)
        self.BUTTON_Einzahlen.place(x=280, y=235)
        
        self.BUTTON_Ueberweisen = Button(self.RAHMEN, text="Ueberweisen", width=15, command=self.Ueberweisen)
        self.BUTTON_Ueberweisen.place(x=280, y=275)

        self.BUTTON_Einziehen = Button(self.RAHMEN, text="Einziehen", width=15, command=self.Einziehen)
        self.BUTTON_Einziehen.place(x=280, y=310)

        self.LABEL_Dest = Label(self.RAHMEN, text="Ziel-Konto", width=30, anchor="w")
        self.LABEL_Dest.place(x=50, y=270)
        self.LABEL_Dest_knr = Label(self.RAHMEN, text="Kontonr.:", width=30, anchor="w")
        self.LABEL_Dest_knr.place(x=50, y=295)
        self.dest_knr = StringVar()
        self.dest_knr.set("")
        self.ENTRY_dest_knr = Entry(self.RAHMEN, textvariable=self.dest_knr, width=5)
        self.ENTRY_dest_knr.place(x=120, y=295)
        self.ENTRY_dest_knr.bind("<Return>", self.AnsichtAktualisieren)
        self.ENTRY_dest_knr.bind("<Button-1>", self.DestKnrLoeschen)

        self.LABEL_Dest_PIN = Label(self.RAHMEN, text="PIN :                                     beim Ueberweisen die PIN des aktuellen Kontos\n                             beim Einziehen die PIN des Zielkontos", width=100, anchor="w")
        self.LABEL_Dest_PIN.place(x=50, y=360)
        self.dest_PIN = StringVar()
        self.dest_PIN.set("")
        self.ENTRY_dest_PIN = Entry(self.RAHMEN, textvariable=self.dest_PIN, width=5, show="*")
        self.ENTRY_dest_PIN.place(x=120, y=360)
        self.ENTRY_dest_PIN.bind("<Button-1>", self.DestPINLoeschen)
        
        self.LABEL_ZielInhaber_Text = Label(self.RAHMEN, text="Inhaber : ", width=30, anchor="w")
        self.LABEL_ZielInhaber_Text.place(x=50, y=320)

        self.LABEL_ZielInhaber = Label(self.RAHMEN, text="", anchor="w")
        self.LABEL_ZielInhaber.place(x=120, y=320)


        self.BUTTON_Schliessen = Button(self.RAHMEN, text="Bank Schliessen ", width=15, command=self.FENSTER.destroy)
        self.BUTTON_Schliessen.place(x=160, y=440)

        self.Bank.BeobachterRegistrieren(self)


    def AnsichtUpdate(self):
        self.AnsichtAktualisieren()
        while 1:
            time.sleep(1)
            self.AnsichtAktualisieren()        
        
    def Update(self):
        self.AnsichtAktualisieren()

    def AnsichtAktualisieren(self, args=[]):
        try:
            if self.knr.get() != "":
                k = self.Bank.GetKonto(int(self.knr.get()))
                self.LABEL_Inhaber["text"] = str(k.Inhaber)
                self.LABEL_Stand["text"] = "EUR %.2f" % (k.Stand)
            else:
                self.LABEL_Inhaber["text"] = ""
                self.LABEL_Stand["text"] = ""
            if self.dest_knr.get() != "":
                d = self.Bank.GetKonto(int(self.dest_knr.get()))
                self.LABEL_ZielInhaber["text"] = str(d.Inhaber)
            else:
                self.LABEL_ZielInhaber["text"] = ""
            self.LABEL_Info["fg"] = "black"
            self.LABEL_Info["text"] = "Ansicht aktualisiert"
        except KontoError, msg:
            self.LABEL_Info["fg"] = "red"
            self.LABEL_Info["text"] = str(msg.value)

    def KnrLoeschen(self, args):
        self.knr.set("")
        self.betrag.set("")
        self.LABEL_Stand["text"] = ""
        self.LABEL_Inhaber["text"] = ""
        
    def DestKnrLoeschen(self, args):
        self.dest_knr.set("")
        self.dest_PIN.set("")
        self.LABEL_ZielInhaber["text"] = ""

    def DestPINLoeschen(self, args):
        self.dest_PIN.set("")
        
    def Kontoauszug(self):
        try:
            k = self.Bank.GetKonto(int(self.knr.get()))
            AuszugDlg(k.Nr, k.GetStatement())
        except KontoError, msg:
            self.LABEL_Info["fg"] = "red"
            self.LABEL_Info["text"] = str(msg.value)

    def KontoEroeffnen(self):
        knr_vergeben = 1
        gewaehlte_knr = self.knr.get()
        while knr_vergeben:
            Dlg = NeuesKontoDlg(self.FENSTER, gewaehlte_knr)
            if Dlg.result <> None:
                gewaehlte_knr = Dlg.knr
                print int(Dlg.knr)
                print Dlg.inhaber
#                print Dlg.pin
                try:                                            # pruefe, ob knr bereits vergeben
                    self.Bank.KontoAnlegen(int(Dlg.knr), Dlg.inhaber, Dlg.pin)
                    print "Knr nicht vergeben"
                    knr_vergeben = 0
                except Exception, msg:
                    self.LABEL_Info["fg"] = "red"
                    self.LABEL_Info["text"] = str(msg)
                    knr_vergeben = 1
            else:
                break
        self.knr.set(gewaehlte_knr)
        self.AnsichtAktualisieren()
        
    def Einzahlen(self):
        try:
            k = self.Bank.GetKonto(int(self.knr.get()))
            k.Gutschreiben("Bareinzahlung", float(self.betrag.get()))
            self.AnsichtAktualisieren()
            self.LABEL_Info["fg"] = "black"
            self.LABEL_Info["text"] = "EUR %.2f" % float(self.betrag.get()) + " auf Konto " + str(self.knr.get()) + " eingezahlt."
        except KontoError, msg:
            self.LABEL_Info["fg"] = "red"
            self.LABEL_Info["text"] = str(msg.value)
    
    def Ueberweisen(self):
        try:
            pin = self.Bank.GetKonto(int(self.knr.get())).PIN
            if pin == encode(self.dest_PIN.get()):
                self.Bank.Transaktion(int(self.knr.get()), self.dest_knr.get(), float(self.betrag.get()), pin)
                self.AnsichtAktualisieren()
                self.LABEL_Info["fg"] = "black"
                self.LABEL_Info["text"] = "EUR %.2f" % float(self.betrag.get()) + " von Konto " + str(self.knr.get()) + " an Konto " + self.dest_knr.get() + " ueberwiesen. " 
            else:
                self.LABEL_Info["fg"] = "red"
                self.LABEL_Info["text"] = str("Falsche PIN-Eingabe fuer Konto " + str(self.knr.get()) + ".")
        except KontoError, msg:
            self.LABEL_Info["fg"] = "red"
            self.LABEL_Info["text"] = str(msg.value)
    
    def Einziehen(self):
        try:
            dest_pin = encode(self.dest_PIN.get())
            self.Bank.Transaktion(self.dest_knr.get(), int(self.knr.get()), float(self.betrag.get()), dest_pin)
            self.AnsichtAktualisieren()
            self.LABEL_Info["fg"] = "black"
            self.LABEL_Info["text"] = "EUR %.2f" % float(self.betrag.get()) + " von Konto " + self.dest_knr.get() + " eingezogen und Konto" + self.knr.get() + " gutgeschrieben."
        except KontoError, msg:
            self.LABEL_Info["fg"] = "red"
            self.LABEL_Info["text"] = str(msg.value)



##  + + +   Test  + + +   Test  + + +   Test  + + +   Test  + + +   Test  + + +   Test  + + 
if __name__ == "__main__":
    B = Bank()
#    # Test-Konto einrichten:
#    B.KontoAnlegen(123, "Hans Wurst", 1234)
#    B.GetKonto(123).Gutschreiben("Bareinzahlung", 100.00)
    BankGUI(B)
    mainloop()

