import thread, time, string, os
from socket import *

from Bank import *

# Software zum Planspiel zum Thema Datenschutz
#
# (C) 2005-2007 Andreas Gramm - http://andreas.grammm.de
#
# Das Planspiel basiert auf der in den "Materialien zum Unterricht des Hessischen
# Instituts fuer Bildungsplanung und Schulentwicklung" 1991 in Wiesbaden veroeffentlichten
# Vorlage "Jugend im Datennetz". Beschreibung des Planspiels und Materialien der Vorlage:
#   http://ddi.informatik.hu-berlin.de/schule/unterrichtsmaterial/JugendImDatennetz.pdf
# Download der an die Software-Variante angepasste Materialien unter:
#   http://www.bebis.de/zielgruppen/lehramtsanwaerterinnen/informatik/Gesellschaft_und_Informatik/
# Hinweise zum Einsatz der Software in der Datei
#   'Hinweise zur Benutzung von Bankserver und Kassenterminals.txt'.
#
# Bugreports und weitere Anregungen willkommen an: planspiel@grammm.de


# B A N K S E R V E R
# Klasse BankServer             Netzwerk-Interface fuer ein Bank-Objekt, das nach Transaktionsanfragen lauscht


class BankServer:

    def __init__(self, bank):

        self.Bank = bank
        self.transaction_lock = thread.allocate_lock()

        self.simul_connect = 5
        self.localhost = ""
        self.port = 7777
        self.configPfad = "BankServer.config"
        try:
            datei = open(self.configPfad, O_RDWR)
            S = read(datei, 10000)
            close(datei)
            self.port = int(S.split(':')[1])
        except OSError:
            print "\n Konnte Datei '" + self.configPfad + "' nicht oeffnen."
        print "\n Port fuer Kommunikation mit Kunden auf '" + str(self.port) + "' gesetzt."
        self.BankSocket = socket(AF_INET, SOCK_STREAM)
        # und weise diese zur Bearbeitung
        self.BankSocket.bind((self.localhost, self.port))        # an einen neuen Thread. 
        self.BankSocket.listen(self.simul_connect)    
        print "\n Bank-Server an Port " + str(self.port) + " eingerichtet."
        print "\n warte auf Anfragen ... \n\n"
        while 1:                                                 # Lausche fuer neue Verbindungen 
            verbindung, adresse = self.BankSocket.accept()    
            thread.start_new(self.AnfrageBearbeiten, (verbindung, adresse))


    def AnfrageBearbeiten(self, verbindung, adresse):            # neue Anfrage
        print " Bank-Server verbunden mit " + str(adresse)
        data = verbindung.recv(1024)
        print " Daten von " + str(adresse) + " erhalten: " + str(data)
        if data:
#######            print data
            dataset = data.split(";")
            mypin = dataset[4]
            print "Codierte PIN: " + mypin
            # Reste der PIN zusammensetzen, falls ';' Teil der codierten PIN war.
            wordcount = len(dataset) 
            print "Durch ';' getrennte Eintraege: " + str(wordcount)
            if wordcount>5:
                pinTeile = dataset[5:wordcount]
                print "Trennzeichen in codierter PIN: "
                print "Liste aller weiteren PIN-Teile: "
                print pinTeile
                # PIN zusammensetzen:
                for teil in pinTeile:
                    mypin = mypin + ';' + teil
                print "Rekonstruierte codierte PIN: " + mypin
#            mypin = decode(mypin)
            try:
                self.transaction_lock.acquire()
                try:
    #  class Bank:  def Transaktion(self, knr_von,    knr_nach,         betrag,          PIN_von):
                    self.Bank.Transaktion(dataset[1], dataset[2], float(dataset[3]), mypin)
                    result = "OK"
                except KontoError, msg:
                    result = str(msg.value)                        
                except TypeError:
                    result = "Falsche Betrag- oder PIN-Angabe"
                self.transaction_lock.release()
            except:
                result = "Buchung fehlgeschlagen."
                self.transaction_lock.release()
            verbindung.send(result)                               # sende Antwort
            print " Antwort an " + str(adresse) + " gesendet: " + result
        print " Beende Verbindung mit" + str(adresse)
        print "\n warte auf weitere Anfragen ... \n"
        verbindung.close()         
