import thread
import time
from os import * 
from socket import *

from Code import *


# Software zum Planspiel zum Thema Datenschutz
#
# (C) 2005-2007 Andreas Gramm - http://andreas.grammm.de
#
# Das Planspiel basiert auf der in den "Materialien zum Unterricht des Hessischen
# Instituts fuer Bildungsplanung und Schulentwicklung" 1991 in Wiesbaden veroeffentlichten
# Vorlage "Jugend im Datennetz". Beschreibung des Planspiels und Materialien der Vorlage:
#   http://ddi.informatik.hu-berlin.de/schule/unterrichtsmaterial/JugendImDatennetz.pdf
# Download der an die Software-Variante angepasste Materialien unter:
#   http://www.bebis.de/zielgruppen/lehramtsanwaerterinnen/informatik/Gesellschaft_und_Informatik/
# Hinweise zum Einsatz der Software in der Datei
#   'Hinweise zur Benutzung von Bankserver und Kassenterminals.txt'.
#
# Bugreports und weitere Anregungen willkommen an: planspiel@grammm.de


# B A N K P R O X Y

# Ueber einen BankProxy kann ein Client mit einer entfernten Bank ueber das
# Netzwerk kommunizieren. Da der Proxy wie die Klasse Bank die Methode
# Transaktion implementiert, ist er fuer den Shop quasi transparent.


class BankProxy:

    def __init__(self):
        self.host = "127.0.0.1"
        self.port = 7777
        self.configPfad = "Bank.config" 
        try:
            datei = open(self.configPfad, O_RDWR)
            S = read(datei, 10000)
            close(datei)
            config = S.split('\n')
            self.host = config[0].split(':')[1]
            self.port = int(config[1].split(':')[1])
        except OSError:
            print "\n Konnte Datei '" + self.configPfad + "' nicht oeffnen."
        print "\n Kommunikation mit Bank auf Host '" + self.host + "' an Port '" + str(self.port) + "' eingerichtet."
        

    def Transaktion(self, knr_von, knr_nach, betrag, PIN_von):
        mysocket=socket(AF_INET,SOCK_STREAM)
        try:
            mysocket.connect((self.host,self.port))
            print "\n Mit Bank-Server auf Host '" + str(self.host) + "' an Port '" + str(self.port) + "' verbunden."
        except:
            print "\n Keine Verbindung mit Bank-Server auf Host '" + str(self.host) + "' an Port '" + str(self.port) + "' moeglich."
            return "Keine Netzwerk-Verbindung zu Bank-Server."
        request = "Transaktionsauftrag;" + str(knr_von) + ";" + str(knr_nach) + ";" + str(betrag) + ";" + encode(str(PIN_von))
        print "   Sende:    " + request
        mysocket.send(str(request))
        result = mysocket.recv(1024)
        print "   Empfange: " + result
        mysocket.close()
        return result


if __name__ == "__main__":
    BankProxy().Transaktion("123", "101", 4.49, "123")

