from Tkinter import *
import tkSimpleDialog
import string

from Shop import *


# Software zum Planspiel zum Thema Datenschutz
#
# (C) 2005-2007 Andreas Gramm - http://andreas.grammm.de
#
# Das Planspiel basiert auf der in den "Materialien zum Unterricht des Hessischen
# Instituts fuer Bildungsplanung und Schulentwicklung" 1991 in Wiesbaden veroeffentlichten
# Vorlage "Jugend im Datennetz". Beschreibung des Planspiels und Materialien der Vorlage:
#   http://ddi.informatik.hu-berlin.de/schule/unterrichtsmaterial/JugendImDatennetz.pdf
# Download der an die Software-Variante angepasste Materialien unter:
#   http://www.bebis.de/zielgruppen/lehramtsanwaerterinnen/informatik/Gesellschaft_und_Informatik/
# Hinweise zum Einsatz der Software in der Datei
#   'Hinweise zur Benutzung von Bankserver und Kassenterminals.txt'.
#
# Bugreports und weitere Anregungen willkommen an: planspiel@grammm.de


# B U E C H E R E I
# Klasse Buecherei(Shop)    container holding a list of books and a cashier with
#                                the current income and a temporary article list.
# Klasse BuchAnzeige             GUI to view details of a book-object
# Klasse BuechereiGUI            GUI to manage a buecherei-object




class Buecherei(Shop):

    anmeldegebuehr = 5.0

    def GetBuch(self, signatur):
        try:
            return self.GetArtikel(signatur)
        except ArtikelError:
            raise ArtikelError("Im System ist kein Buch mit Signatur " + str(signatur) + " registriert.")

    def Ausleihen(self, signatur):
        artikel = self.GetArtikel(signatur)
        try:
            artikel.Verkaufen(1)
        except ArtikelError, msg:
            raise ArtikelError("Alle Exemplare mit Signatur " + str(signatur) + " verliehen.")        
        self.Warenkorb.append((signatur, 1))
        self.Quittung += 13*' ' + "Ausleihe - " + artikel.Bezeichner + "\n"
        
    def Rueckgabe(self, signatur):
        artikel = self.GetArtikel(signatur)
        artikel.Liefern(1)
        self.Quittung += 13*' ' + "Rueckgabe - " + artikel.Bezeichner + "\n"

    def Anmelden(self):
        self.Summe_Warenkorb += Buecherei.anmeldegebuehr
        self.Quittung += 13*' ' + string.ljust("Neuanmeldung",45) + "   EUR " + string.rjust("%.2f" % (Buecherei.anmeldegebuehr),7) + "\n"
        
    def Mahnen(self, betrag):
        self.Summe_Warenkorb += betrag
        self.Quittung += 13*' ' + string.ljust("Mahnung",45) + "   EUR " + string.rjust("%.2f" % (betrag),7) + "\n"
        

class BuchAnzeige:

    def __init__(self, Buch):
        
        self.FENSTER=Tk()   
        self.FENSTER.geometry("450x170")
        self.FENSTER.resizable(width="false", height="false")       # optional

        self.RAHMEN = Frame(self.FENSTER)
        self.RAHMEN.place(x=0, y=0,width=450, height=230)
        self.RAHMEN.master.title("Buch-Anzeige")  # optional

        self.LABEL_Ean = Label(self.RAHMEN, text="Signatur:     " + str(Buch.EAN))
        self.LABEL_Ean.place(x=20, y=20)

        self.LABEL_Bezeichner = Label(self.RAHMEN, text="Titel:     " + Buch.Bezeichner)
        self.LABEL_Bezeichner.place(x=20, y=40)

        self.LABEL_Bestand = Label(self.RAHMEN, text="Bestand:       " + str(Buch.Bestand))
        self.LABEL_Bestand.place(x=20, y=80)

        self.BUTTON_Schliessen = Button(self.RAHMEN, text=" Schliessen ", width=15, command=self.FENSTER.destroy)
        self.BUTTON_Schliessen.place(x=175, y=120)

        

class NeueMahnungDlg(tkSimpleDialog.Dialog):

    def body(self, master):
        self.title("Neue Mahnung")
        self.LABEL_betrag = Label(master, text="Betrag: ")
        self.LABEL_betrag.pack(side=TOP)
        self.ENTRY_betrag = Entry(master,width=7)
        self.ENTRY_betrag.pack(side=TOP)
        return self.ENTRY_betrag # Fokus auf die Eingabezeile setzen
 
    def apply(self): 
        self.betrag = self.ENTRY_betrag.get()
        self.result = 1 ## alles ok!


class BuechereiGUI:

    def __init__(self, buecherei):

        self.buecherei = buecherei
        self.BezahlvorgangAktiv = 0

        self.FENSTER=Tk()
        self.FENSTER.geometry("300x350")
        self.FENSTER.resizable(width="false", height="false")
        self.FENSTER.title(self.buecherei.Name)

        self.RAHMEN = Frame(self.FENSTER)
        self.RAHMEN.place(x=0, y=0,width=300, height=350)

        # Buecherei
        
        self.LABEL_Info = Label(self.RAHMEN, text="Herzlich willkommen bei " + self.buecherei.Name + " ! \n \n ")
        self.LABEL_Info.place(x=20, y=20)

        self.LABEL_Kasse = Label(self.RAHMEN, text="Kassenstand :    EUR " + string.rjust("%.2f" % (self.buecherei.Kasse),7))
        self.LABEL_Kasse.place(x=20, y=50)

        self.LABEL_ZuBezahlen = Label(self.RAHMEN, text="zu bezahlen :     EUR " + string.rjust("%.2f" % (self.buecherei.Summe_Warenkorb),7))
        self.LABEL_ZuBezahlen.place(x=20, y=70)

        self.BUTTON_Anmelden = Button(self.RAHMEN, text="Neuanmeldung", width=12, command=self.Anmelden)
        self.BUTTON_Anmelden.place(x=178, y=45)

        self.BUTTON_Mahnen = Button(self.RAHMEN, text="Mahnung", width=12, command=self.Mahnen)
        self.BUTTON_Mahnen.place(x=178, y=75)

        # Buch-Auswahl
    
        self.LABEL_Auswahl = Label(self.RAHMEN, text="Aktuell ausgewaehltes Buch:")
        self.LABEL_Auswahl.place(x=20, y=95)
        self.LABEL_Auswahl_ean = Label(self.RAHMEN, text="Signatur :")
        self.LABEL_Auswahl_ean.place(x=33, y=123)
        self.Auswahl_ean = StringVar()
        self.Auswahl_ean.set("")
        self.ENTRY_Auswahl_ean = Entry(self.RAHMEN, textvariable=self.Auswahl_ean, width=7)
        self.ENTRY_Auswahl_ean.place(x=90, y=124)
        self.ENTRY_Auswahl_ean.bind("<Return>", self.TitelAktualisieren)
        self.ENTRY_Auswahl_ean.bind("<Button-1>", self.EanLoeschen)

        self.BUTTON_Details = Button(self.RAHMEN, text="Details", width=15, command=self.DetailsAnzeigen)
        self.BUTTON_Details.place(x=160, y=120)

        self.BUTTON_Rueckgabe = Button(self.RAHMEN, text="Zurueckgeben", width=15, command=self.Rueckgabe)
        self.BUTTON_Rueckgabe.place(x=160, y=155)

        self.BUTTON_Ausleihen = Button(self.RAHMEN, text="Ausleihen", width=15, command=self.Ausleihen)
        self.BUTTON_Ausleihen.place(x=35, y=155)

        # Kundendaten / Bezahlen
    
        self.LABEL_Kundendaten = Label(self.RAHMEN, text="Aktueller Kunde:")
        self.LABEL_Kundendaten.place(x=20, y=195)

        self.LABEL_KontoNr_Kunde = Label(self.RAHMEN, text="Kundennr.:")
        self.LABEL_KontoNr_Kunde.place(x=33, y=220)
        self.KontoNr_Kunde = StringVar()
        self.KontoNr_Kunde.set("")
        self.ENTRY_KontoNr_Kunde = Entry(self.RAHMEN, textvariable=self.KontoNr_Kunde, width=7)
        self.ENTRY_KontoNr_Kunde.place(x=90, y=221)
        self.ENTRY_KontoNr_Kunde.bind("<Button-1>", self.KnrKundeLoeschen)
        self.ENTRY_KontoNr_Kunde.bind("<Return>", self.FocusAufPIN)

        self.LABEL_PIN_Kunde = Label(self.RAHMEN, text="PIN :")
        self.LABEL_PIN_Kunde.place(x=195, y=220)
        self.PIN_Kunde = StringVar()
        self.PIN_Kunde.set("")
        self.ENTRY_PIN_Kunde = Entry(self.RAHMEN, textvariable=self.PIN_Kunde, width=5, show="*")
        self.ENTRY_PIN_Kunde.place(x=230, y=221)
        self.ENTRY_PIN_Kunde.bind("<Button-1>", self.PinLoeschen)
        self.ENTRY_PIN_Kunde.bind("<Return>", self.FocusAufBezahlen)

        self.BUTTON_Bezahlen = Button(self.RAHMEN, text="Buchen", width=15, command=self.Bezahlen)
        self.BUTTON_Bezahlen.place(x=35, y=250)

        self.BUTTON_Stornieren = Button(self.RAHMEN, text="Stornieren", width=15, command=self.Stornieren)
        self.BUTTON_Stornieren.place(x=160, y=250)

        self.BUTTON_Schliessen = Button(self.RAHMEN, text=" Buecherei Schliessen ", width=17, command=self.FENSTER.destroy)
        self.BUTTON_Schliessen.place(x=100, y=300)

        self.EanLoeschen()


    def TitelAktualisieren(self, args=[]):
        try:
            aktuelleEan = self.Auswahl_ean.get()
            laenge = len(aktuelleEan)
            if laenge > 3:
                aktuelleEan = aktuelleEan[laenge-3:laenge]
                self.Auswahl_ean.set(aktuelleEan)
            print "\n " + aktuelleEan 
            buch = self.buecherei.GetBuch(aktuelleEan)
            i = 0
            while buch.Bezeichner[i] in [" "]: i+=1            # Leerstellen ausblenden
            self.LABEL_Info["fg"] = "black"
            self.LABEL_Info["text"] = buch.Bezeichner[i:]
            self.BUTTON_Ausleihen.focus_set()
        except ArtikelError, msg:
            self.LABEL_Info["fg"] = "red"
            self.LABEL_Info["text"] = str(msg.value)
            self.EanLoeschen()

    def EanLoeschen(self, args=[]):
        self.Auswahl_ean.set("")
        self.ENTRY_Auswahl_ean.focus_set()
        
    def AnzahlLoeschen(self, args):
        self.Auswahl_anzahl.set("")

    def PinLoeschen(self, args=[]):
        self.PIN_Kunde.set("")

    def KnrKundeLoeschen(self, args=[]):
        self.KontoNr_Kunde.set("")
        self.PIN_Kunde.set("")

    def FocusAufPIN(self, args=[]):
        self.ENTRY_PIN_Kunde.focus_set()

    def FocusAufBezahlen(self, args=[]):
        self.BUTTON_Bezahlen.focus_set()

    def DetailsAnzeigen(self):
        self.TitelAktualisieren()
        try:
            BuchAnzeige(self.buecherei.GetBuch(self.Auswahl_ean.get()))
        except ArtikelError, msg:
            self.LABEL_Info["fg"] = "red"
            self.LABEL_Info["text"] = str(msg.value)

    def Ausleihen(self):
        try:
            self.buecherei.Ausleihen(self.Auswahl_ean.get())
            self.LABEL_Info["fg"] = "black"
            self.LABEL_Info["text"] = "Buch " + self.Auswahl_ean.get() + " ausgeliehen."
            self.EanLoeschen()
        except ArtikelError, msg:
            self.LABEL_Info["fg"] = "red"
            self.LABEL_Info["text"] = str(msg.value)

    def Rueckgabe(self):
        try:
            self.buecherei.Rueckgabe(self.Auswahl_ean.get())
            self.LABEL_Info["fg"] = "black"
            self.LABEL_Info["text"] = "Buch " + self.Auswahl_ean.get() + " zurueckgegeben"  
            self.EanLoeschen()
        except ArtikelError, msg:
            self.LABEL_Info["fg"] = "red"
            self.LABEL_Info["text"] = str(msg.value)

    def Anmelden(self):
        try:
            self.buecherei.Anmelden()
            self.LABEL_ZuBezahlen["text"] = "zu bezahlen :     EUR" + string.rjust(" %.2f" % (self.buecherei.Summe_Warenkorb),7)
            self.LABEL_Info["fg"] = "black"
            self.LABEL_Info["text"] = "Neuen Kunden angemeldet." 
            self.ENTRY_Auswahl_ean.focus_set()
        except ArtikelError, msg:
            self.LABEL_Info["fg"] = "red"
            self.LABEL_Info["text"] = str(msg.value)
        
    def Mahnen(self):
        betrag = 0.0
        while betrag == 0.0:
            Dlg = NeueMahnungDlg(self.FENSTER)
            if Dlg.result <> None:
                try:
                    betrag = float(Dlg.betrag)
                except:
                    pass
            else:
                return
        try:
            self.buecherei.Mahnen(betrag)
            self.LABEL_ZuBezahlen["text"] = "zu bezahlen :     EUR " + string.rjust("%.2f" % (self.buecherei.Summe_Warenkorb),7)
            self.LABEL_Info["fg"] = "black"
            self.LABEL_Info["text"] = "Mahnbegtrag beglichen." 
        except ArtikelError, msg:
            self.LABEL_Info["fg"] = "red"
            self.LABEL_Info["text"] = str(msg.value)
        self.EanLoeschen()        
    
    def Bezahlen(self):
        if not self.BezahlvorgangAktiv:
            self.BezahlvorgangAktiv = 1
            if self.KontoNr_Kunde.get() != "":
                try:
                    self.buecherei.Bezahlen(self.KontoNr_Kunde.get(), self.PIN_Kunde.get())
                    self.LABEL_Kasse["text"] = "Kassenstand :    EUR " + string.rjust("%.2f" % (self.buecherei.Kasse),7)
                    self.LABEL_ZuBezahlen["text"] = "zu bezahlen :     EUR" + string.rjust(" %.2f" % (self.buecherei.Summe_Warenkorb),7)
                    self.EanLoeschen()
                    self.KnrKundeLoeschen()
                    self.LABEL_Info["fg"] = "black"
                    self.LABEL_Info["text"] = "Vorgang bezahlt."
                    self.EanLoeschen()
                    self.BezahlvorgangAktiv = 0
                except ArtikelError, msg:
                    self.LABEL_Info["fg"] = "red"
                    self.LABEL_Info["text"] = str(msg.value)
                    self.BezahlvorgangAktiv = 0
            else:
                self.LABEL_Info["fg"] = "red"
                self.LABEL_Info["text"] = str("Bitte Kontonummer eingeben!")
                self.LABEL_Info["fg"] = "black"
                self.BezahlvorgangAktiv = 0                
        else:
            pass

    def Stornieren(self):
        try:
            self.buecherei.Stornieren()
            self.LABEL_ZuBezahlen["text"] = "zu bezahlen :     EUR " + string.rjust("%.2f" % (self.buecherei.Summe_Warenkorb),7)
            self.EanLoeschen()
            self.KnrKundeLoeschen()
            self.LABEL_Info["fg"] = "black"
            self.LABEL_Info["text"] = "Vorgang storniert."
        except ArtikelError, msg:
            self.LABEL_Info["fg"] = "red"
            self.LABEL_Info["text"] = str(msg.value)
        self.EanLoeschen()


if __name__ == "__main__":
    import BankProxy
    meineBuecherei = Buecherei("Buecherei Neustadt", BankProxy.BankProxy(), "103", 3333)
    BuechereiGUI(meineBuecherei)
    mainloop()
