from Tkinter import *
import string

import Shop


# Software zum Planspiel zum Thema Datenschutz
#
# (C) 2005-2007 Andreas Gramm - http://andreas.grammm.de
#
# Das Planspiel basiert auf der in den "Materialien zum Unterricht des Hessischen
# Instituts fuer Bildungsplanung und Schulentwicklung" 1991 in Wiesbaden veroeffentlichten
# Vorlage "Jugend im Datennetz". Beschreibung des Planspiels und Materialien der Vorlage:
#   http://ddi.informatik.hu-berlin.de/schule/unterrichtsmaterial/JugendImDatennetz.pdf
# Download der an die Software-Variante angepasste Materialien unter:
#   http://www.bebis.de/zielgruppen/lehramtsanwaerterinnen/informatik/Gesellschaft_und_Informatik/
# Hinweise zum Einsatz der Software in der Datei
#   'Hinweise zur Benutzung von Bankserver und Kassenterminals.txt'.
#
# Bugreports und weitere Anregungen willkommen an: planspiel@grammm.de


# D I S C O
# Klasse ShopDisplay                frame to display information on selected articles
# Klasse DiscoGUI                   GUI to manage a Disco-Shop-object



class DiscoGUI:

    def __init__(self, shop, farbe="blue"):

        self.shop = shop
        self.BezahlvorgangAktiv = 0

        self.FENSTER=Tk()
        self.FENSTER.geometry("300x410")
        self.FENSTER.resizable(width="false", height="false")
        self.FENSTER.title(self.shop.Name)

        self.RAHMEN = Frame(self.FENSTER)
        self.RAHMEN.place(x=0, y=60,width=300, height=350)

        # Shop
        
        self.LABEL_Info = Label(self.RAHMEN, text="")
        self.LABEL_Info.place(x=20, y=40)

        self.LABEL_Kasse = Label(self.RAHMEN, text="Kassenstand :    EUR " + string.rjust("%.2f" % (self.shop.Kasse),7))
        self.LABEL_Kasse.place(x=20, y=70)

        # Artikel-Auswahl
    
        self.LABEL_Auswahl_anzahl = Label(self.RAHMEN, text="Anzahl :")
        self.LABEL_Auswahl_anzahl.place(x=33, y=98)
        self.Auswahl_anzahl = StringVar()
        self.Auswahl_anzahl.set("1")
        self.ENTRY_Auswahl_anzahl = Entry(self.RAHMEN, textvariable=self.Auswahl_anzahl, width=5)
        self.ENTRY_Auswahl_anzahl.place(x=93, y=99)
        self.ENTRY_Auswahl_anzahl.bind("<Button-1>", self.AnzahlLoeschen)

        self.Rabatt = IntVar()
        self.Rabatt.set(0)
        self.CHECKBUTTON_Eintritt = Checkbutton(self.RAHMEN, text="Rabatt", variable=self.Rabatt)
        self.CHECKBUTTON_Eintritt.place(x=33, y=135)

        self.BUTTON_Getraenk = Button(self.RAHMEN, text="Getraenk", width=15, command=self.GetraenkVerkaufen)
        self.BUTTON_Getraenk.place(x=160, y=95)

        self.BUTTON_Eintritt = Button(self.RAHMEN, text="Eintritt", width=15, command=self.EintrittVerkaufen)
        self.BUTTON_Eintritt.place(x=160, y=135)

        # Kundendaten / Bezahlen
    
        self.LABEL_Kundendaten = Label(self.RAHMEN, text="Aktueller Kunde:")
        self.LABEL_Kundendaten.place(x=20, y=195)
        self.LABEL_KontoNr_Kunde = Label(self.RAHMEN, text="Konto-Nr :")
        self.LABEL_KontoNr_Kunde.place(x=33, y=220)
        self.KontoNr_Kunde = StringVar()
        self.KontoNr_Kunde.set("")
        self.ENTRY_KontoNr_Kunde = Entry(self.RAHMEN, textvariable=self.KontoNr_Kunde, width=5)
        self.ENTRY_KontoNr_Kunde.place(x=90, y=221)
        self.ENTRY_KontoNr_Kunde.bind("<Button-1>", self.KnrKundeLoeschen)
        self.ENTRY_KontoNr_Kunde.bind("<Return>", self.FocusAufPIN)

        self.LABEL_PIN_Kunde = Label(self.RAHMEN, text="PIN :")
        self.LABEL_PIN_Kunde.place(x=195, y=220)
        self.PIN_Kunde = StringVar()
        self.PIN_Kunde.set("")
        self.ENTRY_PIN_Kunde = Entry(self.RAHMEN, textvariable=self.PIN_Kunde, width=5, show="*")
        self.ENTRY_PIN_Kunde.place(x=230, y=221)
        self.ENTRY_PIN_Kunde.bind("<Button-1>", self.PinLoeschen)
        self.ENTRY_PIN_Kunde.bind("<Return>", self.FocusAufBezahlen)

        self.BUTTON_Bezahlen = Button(self.RAHMEN, text="Bezahlen", width=15, command=self.Bezahlen)
        self.BUTTON_Bezahlen.place(x=35, y=250)

        self.BUTTON_Stornieren = Button(self.RAHMEN, text="Stornieren", width=15, command=self.Stornieren)
        self.BUTTON_Stornieren.place(x=160, y=250)

        self.BUTTON_Schliessen = Button(self.RAHMEN, text="Disco Schliessen ", width=15, command=self.Schliessen)
        self.BUTTON_Schliessen.place(x=100, y=300)
        
        self.display = Shop.ShopDisplay(self.FENSTER, farbe)
        self.display.GetRahmen().place(x=0, y=0,width=300, height=90)

        self.ENTRY_Auswahl_anzahl.focus_set()
        

    def GetraenkVerkaufen(self):
        try:
            ean = "200"
            self.shop.ArtikelInWarenkorb(ean, int(self.Auswahl_anzahl.get()))
            self.LABEL_Info["fg"] = "black"
            self.LABEL_Info["text"] = self.Auswahl_anzahl.get() + "x " + self.shop.GetArtikel(ean).Bezeichner + " berechnet."
            self.display.ArtikelAktualisieren(self.shop.GetArtikel(ean))
            self.display.SummeAktualisieren(self.shop.Summe_Warenkorb)
            self.Auswahl_anzahl.set("1")
        except Shop.ArtikelError, msg:
            self.LABEL_Info["fg"] = "red"
            self.LABEL_Info["text"] = str(msg.value)

    def EintrittVerkaufen(self):
        try:
            ean = "100"
            if self.Rabatt.get():
                ean = "101"
            self.shop.ArtikelInWarenkorb(ean, int(self.Auswahl_anzahl.get()))
            self.LABEL_Info["fg"] = "black"
            self.LABEL_Info["text"] = self.Auswahl_anzahl.get() + "x " + self.shop.GetArtikel(ean).Bezeichner + " berechnet."
            self.display.ArtikelAktualisieren(self.shop.GetArtikel(ean))
            self.display.SummeAktualisieren(self.shop.Summe_Warenkorb)
            self.Auswahl_anzahl.set("1")
        except Shop.ArtikelError, msg:
            self.LABEL_Info["fg"] = "red"
            self.LABEL_Info["text"] = str(msg.value)

    def AnzahlLoeschen(self, args):
        self.Auswahl_anzahl.set("")

    def PinLoeschen(self, args):
        self.PIN_Kunde.set("")

    def KnrKundeLoeschen(self, args=[]):
        self.KontoNr_Kunde.set("")
        self.PIN_Kunde.set("")

    def FocusAufPIN(self, args=[]):
        self.ENTRY_PIN_Kunde.focus_set()

    def FocusAufBezahlen(self, args=[]):
        self.BUTTON_Bezahlen.focus_set()

    def Bezahlen(self):
        if not self.BezahlvorgangAktiv:
            self.BezahlvorgangAktiv = 1
            if self.KontoNr_Kunde.get() != "":
                try:
                    self.shop.Bezahlen(self.KontoNr_Kunde.get(), self.PIN_Kunde.get())
                    self.LABEL_Kasse["text"] = "Kassenstand :    EUR %.2f" % (self.shop.Kasse)
                    self.LABEL_Info["fg"] = "black"
                    self.LABEL_Info["text"] = "Artikelauswahl bezahlt."
                    self.Auswahl_anzahl.set("1")
                    self.KnrKundeLoeschen()
                    self.display.NeuerKunde()
                    self.BezahlvorgangAktiv = 0
                    self.ENTRY_Auswahl_anzahl.focus_set()
                except Shop.ArtikelError, msg:
                    self.LABEL_Info["fg"] = "red"
                    self.LABEL_Info["text"] = str(msg.value)
                    self.BezahlvorgangAktiv = 0
            else:
                self.LABEL_Info["fg"] = "red"
                self.LABEL_Info["text"] = str("Bitte Kontonummer eingeben!")
                self.BezahlvorgangAktiv = 0                
        else:
            pass

    def Stornieren(self):
        self.shop.Stornieren()
        self.LABEL_Info["fg"] = "black"
        self.LABEL_Info["text"] = "Artikelauswahl storniert."
        self.Auswahl_anzahl.set("1")
        self.KnrKundeLoeschen()
        self.display.NeuerKunde()
        self.ENTRY_Auswahl_anzahl.focus_set()

    def Schliessen(self):
        self.FENSTER.destroy()


if __name__ == "__main__":
    import BankProxy
    meineDisco = Shop.Shop("Diskothek j-b", BankProxy.BankProxy(), "104", 4444)
    DiscoGUI(meineDisco, "blue")
    mainloop()
