from Tkinter import *
from tkFont import *
from os import * 
from time import *
import string


# Software zum Planspiel zum Thema Datenschutz
#
# (C) 2005-2007 Andreas Gramm - http://andreas.grammm.de
#
# Das Planspiel basiert auf der in den "Materialien zum Unterricht des Hessischen
# Instituts fuer Bildungsplanung und Schulentwicklung" 1991 in Wiesbaden veroeffentlichten
# Vorlage "Jugend im Datennetz". Beschreibung des Planspiels und Materialien der Vorlage:
#   http://ddi.informatik.hu-berlin.de/schule/unterrichtsmaterial/JugendImDatennetz.pdf
# Download der an die Software-Variante angepasste Materialien unter:
#   http://www.bebis.de/zielgruppen/lehramtsanwaerterinnen/informatik/Gesellschaft_und_Informatik/
# Hinweise zum Einsatz der Software in der Datei
#   'Hinweise zur Benutzung von Bankserver und Kassenterminals.txt'.
#
# Bugreports und weitere Anregungen willkommen an: planspiel@grammm.de


# S H O P
# Klasse Artikel                    description of one type of article
# Klasse ArtikelError(Exception)    generic Exception for problems related to handling
#                                   articles (non-existing ean, insufficient supply in stock, ...)
# Klasse Shop                       container holding a list of articles and a cashier with
#                                   the current income and a temporary article list.
# Klasse ArtikelAnzeige             GUI to view details of an Article-object
# Klasse ShopDisplay                frame to display information on selected articles
# Klasse ShopGUI                    GUI to manage a Shop-object



class Artikel:

    def __init__(self, ean, bezeichner, preis):
        self.EAN = ean
        self.Bezeichner = bezeichner
        self.Preis = float(preis)
        self.Bestand = 0

    def Liefern(self, anzahl):
        self.Bestand = self.Bestand + anzahl

    def Verkaufen(self, anzahl):
        if self.Bestand < anzahl:
            raise ArtikelError("Nicht genuegend Artikel mit EAN " + str(self.EAN) + " vorhanden.")
        self.Bestand = self.Bestand - anzahl
        


class ArtikelError(Exception):    
    def __init__(self, msg):
        self.value = msg
    def __str__(self):
        return repr(self.value)
            


class ArtikelAnzeige:
    def __init__(self, artikel):
        
        self.FENSTER=Tk()   
        self.FENSTER.geometry("250x170")
        self.FENSTER.resizable(width="false", height="false")       # optional

        self.RAHMEN = Frame(self.FENSTER)
        self.RAHMEN.place(x=0, y=0,width=250, height=230)
        self.RAHMEN.master.title("Artikel-Anzeige")  # optional

        self.LABEL_Ean = Label(self.RAHMEN, text="EAN:            " + artikel.EAN)
        self.LABEL_Ean.place(x=20, y=20)

        i = 0
        while artikel.Bezeichner[i] in [" ", "\t"]: i+=1            # Leerstellen ausblenden
        self.LABEL_Bezeichner = Label(self.RAHMEN, text="Bezeichner:  " + artikel.Bezeichner[i:])
        self.LABEL_Bezeichner.place(x=20, y=40)

        self.LABEL_Preis = Label(self.RAHMEN, text="Preis:            EUR %.2f" % (artikel.Preis))
        self.LABEL_Preis.place(x=20, y=60)

        self.LABEL_Bestand = Label(self.RAHMEN, text="Bestand:       " + str(artikel.Bestand))
        self.LABEL_Bestand.place(x=20, y=80)

        self.BUTTON_Schliessen = Button(self.RAHMEN, text=" Schliessen ", width=15, command=self.FENSTER.destroy)
        self.BUTTON_Schliessen.place(x=75, y=120)
        


class Shop:

    fileprefix_Abrechnung = "Abrechnung_"
    fileprefix_Artikel = "Artikelliste_"
    filepostfix = ".txt"

    def __init__(self, name, bank, kontonr, pin):
        self.Name = name
        self.Kasse = 0.0            # float - Gesamteinnahmen der Kasse
        self.Artikelliste = []      # Liste von Artikel-Objekten
        self.Warenkorb = []         # Liste von Tupeln (ean:str, anzahl:int) fuer zu ausgewaehlte Artikel   
        self.Summe_Warenkorb = 0.0  # float - Wert des aktuell eingelesenen Warenkorbs
        self.Quittung = "\n\n\n             + + +  Herzlich willkommen bei " + self.Name + "  + + +\n\n"
        self.Bank = bank
        self.KontoNr = kontonr
        self.PIN = pin
        try:
            datei = open(Shop.fileprefix_Abrechnung + str(self.Name) + Shop.filepostfix, O_RDWR)
            S = read(datei, 10000).split(' ')
            close(datei)
            try:
                self.Kasse = float(S[len(S)-1])
            except:
                pass
        except OSError:
            datei = open(Shop.fileprefix_Abrechnung + str(self.Name) + Shop.filepostfix, O_CREAT)
            close(datei)
            datei = open(Shop.fileprefix_Abrechnung + str(self.Name) + Shop.filepostfix, O_RDWR)
            write(datei, "\n Abrechnung fuer " + self.Name + ", Konto-Nr " + str(self.KontoNr) + ", eingerichtet am " + strftime("%d.%m.%y um %H:%M:%S ", localtime()) + "\n\n")
            write(datei, "                   Kassenstand:  EUR    0.00\n")
            close(datei)
        print "\n Bisheriger Kassenstand: %.2f" % (self.Kasse)
        try:
            datei = open(Shop.fileprefix_Artikel + str(self.Name) + Shop.filepostfix, O_RDWR)
            S = read(datei, 10000)
            close(datei)
            Artikelliste = S.split("\n")
            Artikelliste = Artikelliste[5:len(Artikelliste)-1]
            print "\n " + str(len(Artikelliste)) + " Artikel eingelesen.\n"
            for AS in Artikelliste:
                ArtikelStr = AS.split(" | ")
                preis = 0.0
                try:                                # setze Preis, falls angegeben
                    preis = float(ArtikelStr[2])
                except:
                    pass
                a = Artikel(ArtikelStr[0], ArtikelStr[1].split('\t')[1], preis)
                try:                                # setze Preis, falls angegeben
                    a.Liefern(int(ArtikelStr[3]))
                except:
                    a.Liefern(5)
                self.NeuerArtikel(a)
        except OSError:
            datei = open(Shop.fileprefix_Artikel + str(self.Name) + Shop.filepostfix, O_CREAT)
            close(datei)
            datei = open(Shop.fileprefix_Artikel + str(self.Name) + Shop.filepostfix, O_RDWR)
            write(datei, "\n Artikelliste fuer" + self.Name + ", eingerichtet " + strftime("am %d.%m.%y um %H:%M:%S ", localtime()))
            close(datei)
        
    def NeuerArtikel(self, artikel):
        self.Artikelliste.append(artikel)

    def GetArtikel(self, ean):
        for a in self.Artikelliste:
            if a.EAN == ean:
                return a
        raise ArtikelError("Im System ist kein Artikel mit EAN " + str(ean) + " registriert.")

    def Liefern(self, ean, anzahl):
        self.GetArtikel(ean).Liefern(anzahl)

    def ArtikelInWarenkorb(self, ean, anzahl):
        artikel = self.GetArtikel(ean)
        artikel.Verkaufen(anzahl)
        self.Warenkorb.append((ean, anzahl))
        self.Quittung += string.rjust(str(anzahl),10) + "x  " + string.ljust(artikel.Bezeichner,30)[0:29] +  " a EUR"  
        self.Quittung += string.rjust("%.2f" % (artikel.Preis),7) + "      EUR " + string.rjust("%.2f" % (artikel.Preis * anzahl),7) + "\n"
        self.Summe_Warenkorb += artikel.Preis * anzahl

    def Bezahlen(self, KontoNr_Kunde, PIN_Kunde):
            if (len(self.Warenkorb) == 0) & (self.Summe_Warenkorb == 0):
                raise ArtikelError("Es wurden keine Artikel ausgewaehlt.")
            try:                                # Betrag bei der Bank von Kundenkonto abbuchen:
                bankBericht = self.Bank.Transaktion(KontoNr_Kunde, self.KontoNr, self.Summe_Warenkorb, PIN_Kunde)

                if bankBericht == "OK" :

                    self.Kasse = self.Kasse + self.Summe_Warenkorb

                    self.Quittung +=   "\n" + 54*' ' + "Summe: EUR " + string.rjust("%.2f" % (self.Summe_Warenkorb),7)
                    self.Quittung += "\n\n             Bezahlt " + strftime("am %d.%m.%y um %H:%M:%S", localtime()) + " mit Karte: " + str(KontoNr_Kunde)
                    self.Quittung += "\n\n             Neuer Kassenstand:  EUR " + string.rjust("%.2f" % (self.Kasse),7) + "\n"
                    datei = open(Shop.fileprefix_Abrechnung + str(self.Name) + Shop.filepostfix, O_RDWR)
                    S = read(datei, 10000)
                    write(datei, self.Quittung)
                    close(datei)

                    self.Summe_Warenkorb = 0
                    self.Warenkorb = []
                    self.Quittung =  "\n\n\n             + + +  Herzlich willkommen bei " + self.Name + "  + + +\n\n"
                else:
                    raise ArtikelError(bankBericht)            
            except ArtikelError, msg:
                raise ArtikelError("Konnte Betrag nicht von Konto " + KontoNr_Kunde + " abbuchen:\n" + msg.value)
            except OSError:
                raise ArtikelError("Konnte Abrechnungs-Datei fuer " + self.Name + " nicht oeffnen" )

    def Stornieren(self):
        for t in self.Warenkorb:            # Artikel zurueckbuchen
            self.Liefern(t[0], t[1])
        self.Warenkorb = []
        self.Summe_Warenkorb = 0
        self.Quittung =  "\n\n\n             + + +  Herzlich willkommen bei " + self.Name + "  + + +\n\n"
        

class ShopDisplay:

    hintergrundfarbe = "black"    

    def __init__(self, fenster, farbe="green"):
        self.FENSTER = fenster
        self.RAHMEN = Frame(self.FENSTER, bg="black")

        schriftart = Font(family="Arial", size="12") # , weight="bold")
        
        self.LABEL_Artikel = Label(self.FENSTER, text=" Herzlich Willkommen! ", fg=farbe, bg=ShopDisplay.hintergrundfarbe, font=schriftart)
        self.LABEL_Artikel.place(x=20, y=20)

        self.LABEL_Preis = Label(self.FENSTER, text=" EUR 0.00", fg=farbe, bg=ShopDisplay.hintergrundfarbe, font=schriftart)
        self.LABEL_Preis.place(x=20, y=55)

        self.LABEL_Summe = Label(self.FENSTER, text=" Summe:  EUR 0.00", fg=farbe, bg=ShopDisplay.hintergrundfarbe, font=schriftart)
        self.LABEL_Summe.place(x=120, y=55)

    def ArtikelAktualisieren(self, artikel):
        i = 0
        while artikel.Bezeichner[i] in [" ", "\t"]: i+=1            # Leerstellen ausblenden
        self.LABEL_Artikel["text"] = " " + artikel.Bezeichner[i:]
        self.LABEL_Preis["text"] = " EUR " + string.rjust("%.2f" % (artikel.Preis),7)

    def SummeAktualisieren(self, summe):
        self.LABEL_Summe["text"] = " Summe:  EUR " + string.rjust("%.2f" % (summe),7)

    def NeuerKunde(self):
        self.LABEL_Artikel["text"] = " Herzlich Willkommen! "
        self.LABEL_Preis["text"] = " EUR 0.00"
        self.LABEL_Summe["text"] = " Summe:  EUR 0.00"

    def GetRahmen(self):
        return self.RAHMEN

class ShopGUI:

    def __init__(self, shop, farbe="green"):

        self.shop = shop
        self.BezahlvorgangAktiv = 0

        self.FENSTER=Tk()
        self.FENSTER.geometry("300x400")
        self.FENSTER.resizable(width="false", height="false")
        self.FENSTER.title(self.shop.Name)

        self.RAHMEN = Frame(self.FENSTER)
        self.RAHMEN.place(x=0, y=55,width=300, height=350)


        # Shop
        
        self.LABEL_Info = Label(self.RAHMEN, text="")
        self.LABEL_Info["fg"] = "black"
        self.LABEL_Info.place(x=20, y=40)

        self.LABEL_Kasse = Label(self.RAHMEN, text="Kassenstand :    EUR %.2f" % (self.shop.Kasse))
        self.LABEL_Kasse.place(x=20, y=70)

        # Artikel-Auswahl
    
        self.LABEL_Auswahl = Label(self.RAHMEN, text="Aktuell ausgewaehlter Artikel:")
        self.LABEL_Auswahl.place(x=20, y=95)
        self.LABEL_Auswahl_ean = Label(self.RAHMEN, text="EAN :")
        self.LABEL_Auswahl_ean.place(x=38, y=123)
        self.Auswahl_ean = StringVar()
        self.Auswahl_ean.set("")
        self.ENTRY_Auswahl_ean = Entry(self.RAHMEN, textvariable=self.Auswahl_ean, width=5)
        self.ENTRY_Auswahl_ean.place(x=95, y=124)
        self.ENTRY_Auswahl_ean.bind("<Return>", self.ArtikelAktualisieren)
        self.ENTRY_Auswahl_ean.bind("<Button-1>", self.EanLoeschen)

        self.LABEL_Auswahl_anzahl = Label(self.RAHMEN, text="Anzahl :")
        self.LABEL_Auswahl_anzahl.place(x=180, y=123)
        self.Auswahl_anzahl = StringVar()
        self.Auswahl_anzahl.set("1")
        self.ENTRY_Auswahl_anzahl = Entry(self.RAHMEN, textvariable=self.Auswahl_anzahl, width=5)
        self.ENTRY_Auswahl_anzahl.place(x=230, y=124)
        self.ENTRY_Auswahl_anzahl.bind("<Return>", self.ArtikelAktualisieren)
        self.ENTRY_Auswahl_anzahl.bind("<Button-1>", self.AnzahlLoeschen)

        # Kundendaten / Bezahlen
    
        self.LABEL_Kundendaten = Label(self.RAHMEN, text="Aktueller Kunde:")
        self.LABEL_Kundendaten.place(x=20, y=195)
        self.LABEL_KontoNr_Kunde = Label(self.RAHMEN, text="Konto-Nr :")
        self.LABEL_KontoNr_Kunde.place(x=38, y=220)
        self.KontoNr_Kunde = StringVar()
        self.KontoNr_Kunde.set("")
        self.ENTRY_KontoNr_Kunde = Entry(self.RAHMEN, textvariable=self.KontoNr_Kunde, width=5)
        self.ENTRY_KontoNr_Kunde.place(x=95, y=221)
        self.ENTRY_KontoNr_Kunde.bind("<Button-1>", self.KnrKundeLoeschen)
        self.ENTRY_KontoNr_Kunde.bind("<Return>", self.FocusAufPIN)

        self.LABEL_PIN_Kunde = Label(self.RAHMEN, text="PIN :")
        self.LABEL_PIN_Kunde.place(x=195, y=220)
        self.PIN_Kunde = StringVar()
        self.PIN_Kunde.set("")
        self.ENTRY_PIN_Kunde = Entry(self.RAHMEN, textvariable=self.PIN_Kunde, width=5, show="*")
        self.ENTRY_PIN_Kunde.place(x=230, y=221)
        self.ENTRY_PIN_Kunde.bind("<Button-1>", self.PinLoeschen)
        self.ENTRY_PIN_Kunde.bind("<Return>", self.FocusAufBezahlen)

        self.BUTTON_Details = Button(self.RAHMEN, text="Details anzeigen", width=15, command=self.DetailsAnzeigen)
        self.BUTTON_Details.place(x=35, y=155)

        self.BUTTON_ArtikelInWarenkorb = Button(self.RAHMEN, text="in den Warenkorb", width=15, command=self.ArtikelInWarenkorb)
        self.BUTTON_ArtikelInWarenkorb.place(x=160, y=155)

        self.BUTTON_Bezahlen = Button(self.RAHMEN, text="Bezahlen", width=15, command=self.Bezahlen)
        self.BUTTON_Bezahlen.place(x=35, y=250)

        self.BUTTON_Stornieren = Button(self.RAHMEN, text="Stornieren", width=15, command=self.Stornieren)
        self.BUTTON_Stornieren.place(x=160, y=250)

        self.BUTTON_Schliessen = Button(self.RAHMEN, text="Laden Schliessen ", width=15, command=self.Schliessen)
        self.BUTTON_Schliessen.place(x=100, y=300)
        
        self.display = ShopDisplay(self.FENSTER, farbe)
        self.display.GetRahmen().place(x=0, y=0,width=300, height=90)

        self.EanLoeschen()


    def ArtikelAktualisieren(self, args=[]):
        self.LABEL_Info["fg"] = "black"
        self.LABEL_Info["text"] = str("")
        try:
            aktuelleEan = self.Auswahl_ean.get()
            laenge = len(aktuelleEan)
            if laenge > 3:
                aktuelleEan = aktuelleEan[laenge-3:laenge]
                self.Auswahl_ean.set(aktuelleEan)
            print "\n " + aktuelleEan + " registriert."
            artikel = self.shop.GetArtikel(aktuelleEan)
            self.display.ArtikelAktualisieren(artikel)
            self.BUTTON_ArtikelInWarenkorb.focus_set()
        except ArtikelError, msg:
            self.LABEL_Info["fg"] = "red"
            self.LABEL_Info["text"] = str(msg.value)

    def EanLoeschen(self, args=[]):
        self.Auswahl_anzahl.set("1")
        self.Auswahl_ean.set("")
        self.ENTRY_Auswahl_ean.focus_set()

    def AnzahlLoeschen(self, args):
        self.Auswahl_anzahl.set("")

    def PinLoeschen(self, args):
        self.PIN_Kunde.set("")

    def KnrKundeLoeschen(self, args=[]):
        self.KontoNr_Kunde.set("")
        self.PIN_Kunde.set("")

    def FocusAufPIN(self, args=[]):
        self.ENTRY_PIN_Kunde.focus_set()

    def FocusAufBezahlen(self, args=[]):
        self.BUTTON_Bezahlen.focus_set()

    def DetailsAnzeigen(self):
        self.ArtikelAktualisieren()
        try:
            ArtikelAnzeige(self.shop.GetArtikel(self.Auswahl_ean.get()))
        except ArtikelError, msg:
            self.LABEL_Info["fg"] = "red"
            self.LABEL_Info["text"] = str(msg.value)
            
    def ArtikelInWarenkorb(self, args=[]):
        try:
            self.shop.ArtikelInWarenkorb(self.Auswahl_ean.get(), int(self.Auswahl_anzahl.get()))
            self.LABEL_Info["fg"] = "black"
            self.LABEL_Info["text"] = self.Auswahl_anzahl.get() + "x Artikel " + self.Auswahl_ean.get() + " dem Warenkorb hinzugefuegt."
            self.display.SummeAktualisieren(self.shop.Summe_Warenkorb)
            self.EanLoeschen()
        except ArtikelError, msg:
            self.LABEL_Info["fg"] = "red"
            self.LABEL_Info["text"] = str(msg.value)

    def Bezahlen(self):
        if not self.BezahlvorgangAktiv:
            self.BezahlvorgangAktiv = 1
            if self.KontoNr_Kunde.get() != "":
                try:
                    self.shop.Bezahlen(self.KontoNr_Kunde.get(), self.PIN_Kunde.get())
                    self.LABEL_Kasse["text"] = "Kassenstand :    EUR " + string.rjust("%.2f" % (self.shop.Kasse),7)
                    self.LABEL_Info["fg"] = "black"
                    self.LABEL_Info["text"] = "Artikelauswahl bezahlt."
                    self.Auswahl_anzahl.set("1")
                    self.KnrKundeLoeschen()
                    self.display.NeuerKunde()
                    self.EanLoeschen()
                    self.BezahlvorgangAktiv = 0
                except ArtikelError, msg:
                    self.LABEL_Info["fg"] = "red"
                    self.LABEL_Info["text"] = str(msg.value)
                    self.BezahlvorgangAktiv = 0
            else:
                self.LABEL_Info["fg"] = "red"
                self.LABEL_Info["text"] = str("Bitte Kontonummer eingeben!")
                self.BezahlvorgangAktiv = 0                
        else:
            pass

    def Stornieren(self):
        try:
            self.shop.Stornieren()
            self.LABEL_Info["fg"] = "black"
            self.LABEL_Info["text"] = "Artikelauswahl storniert."
            self.KnrKundeLoeschen()
            self.display.NeuerKunde()
            self.EanLoeschen()
        except Exception, msg:
            self.LABEL_Info["fg"] = "red"
            self.LABEL_Info["text"] = msg.value

    def Schliessen(self):
        self.FENSTER.destroy()


if __name__ == "__main__":
    import BankProxy
    # Pro Prozess laesst sich nur ein ShopGUI-Objekt erstellen.
    meinSupermarkt = Shop("Supermarkt Spar", BankProxy.BankProxy(), "101", 1111)
    ShopGUI(meinSupermarkt, "darkcyan")
#    meinKaufhaus = Shop("Kaufhaus Galeria", BankProxy.BankProxy(), "102", 2222)
#    ShopGUI(meinKaufhaus, "orange")
    mainloop()
